#include "StdAfx.h"
#include "SampleGrabberCB.h"

//=====================================================================================//
//                                class SampleGrabberCB                                //
//=====================================================================================//
SampleGrabberCB::SampleGrabberCB()
: m_cRef(0)
{
}

SampleGrabberCB::~SampleGrabberCB()
{
}

HRESULT SampleGrabberCB::QueryInterface(REFIID refiid, void **ppv)
{
	if(refiid  == IID_IUnknown || refiid == IID_ISampleGrabberCB)
		*ppv = this;
	else
		return E_NOINTERFACE;

	static_cast<IUnknown*>(this)->AddRef();

	return S_OK;
}

ULONG SampleGrabberCB::AddRef()
{
	return InterlockedIncrement(&m_cRef);
}

ULONG SampleGrabberCB::Release()
{
	ULONG ul = 0;
	if(0 == (ul = InterlockedDecrement(&m_cRef)))
		delete this;

	return ul;
}
